-- Delete Page for Abigail 2.40
-- 14/4/2014

local abiDeleteText={}
local abiRealmHistory={}
local abiFactionHistory={}
local abiNameHistory={}
local abiTimeHistory={}
local abiRecordsHistory={}
local abiDeleteTableOffset=0
local abiDeleteWhich=0
local abiDelPopup=0
local abiDelRecords=0
local abiOldRecords=0

abiDeleteText[1]="Delete scan records that you no longer require"



function abiDeletingSliderValueChanged()
	local n
	n=abiDeletingSlider1FindValue()
	abiDeletingSlider1Text:SetText(n.." days")
end



function abiDeletingSlider1FindValue()

	local t,n
	t=abiDeletingSlider1:GetValue()
	n=30
	if t>=30 and t<60 then
		n=30
	end
	if t>=60 and t<90 then
		n=60
	end
	if t>=90 and t<120 then
		n=90
	end
	if t>=120 then
		n=120
	end
	return n
end



function abiDeleteFrameHelp(passed)
	abiDeleteHelp:SetText("|cffffffff"..abiDeleteText[passed])
end



function abiDeleteFrame_OnLoad()
	abiDeletingFrame:Hide()
	abiDeletingOldButton:Disable()
	abiPLButton.tooltipText="|cffffff00Resets the Spent, Earned|nand Profit values back|nto zero.|n|nWarning - This Cannot Be Undone."
end



function abiDeletingSlider1_OnLoad(slider)
	_G[slider.."Low"]:SetText("30")
	_G[slider.."High"]:SetText("120")
	_G[slider.."Text"]:SetText("30 days")
	abiDeletingSlider1.tooltipText="Choose 30, 60,|n90 or 120 days"
end



function abiDeleteButtonClicked(which,button)
	abiDeleteWhich=which
	if button=="LeftButton" then
		abiDisableAll()
		AuctionFrame:SetAlpha(0.5)
		abiDelPopup=1
		StaticPopup_Show("abiDeleteRecords")
	end
end



function abiDoTheDelete()
		local t=abiDeleteWhich+abiDeleteTableOffset
		local t2=abiRealmHistory[t]..abiFactionHistory[t]
		local t3=GetRealmName()..abiMyFaction

		-- first do the abiPriceIndex table
		local abiTempTable1={}
		local abiTempTable2={}
		local abiTempTable3={}
		local abiTempTable4={}

		for k,v in pairs(abiPriceIndex) do
			if k~=t2 then
				abiTempTable1[k]={}
				for k2,v2 in pairs(abiPriceIndex[k]) do
					abiTempTable1[k][k2]=v2
				end
			end
		end
		abiTempTable1[t2]=nil
		abiPriceIndex=table.wipe(abiPriceIndex)
		abiPriceIndex=abiTempTable1
			
		-- Now remove info from abiPlayerList
		for k,v in pairs(abiPlayerList) do
			if k~=t2 then
				abiTempTable2[k]=v
			end
		end
		abiPlayerList=table.wipe(abiPlayerList)
		abiPlayerList=abiTempTable2

		-- Now need to remove the Shopping List info
		for k,v in pairs(abiShoppingList) do
			if k~=t2 then
				abiTempTable3[k]={}
				for k2,v2 in pairs(abiShoppingList[k]) do
					abiTempTable3[k][k2]=v2
				end
			end
		end
		abiShoppingList=table.wipe(abiShoppingList)
		abiShoppingList=abiTempTable3

		-- now remove the abiBargains data if we have deleted current realm/faction
		if abiRealm==abiRealmHistory[t]..abiFactionHistory[t] then
			abiBargains=table.wipe(abiBargains)
			abiAHImage=table.wipe(abiAHImage)
			abiReadPricesButtonClicked("LeftButton",0)
		end

		-- now remove abiPLV for this realm/faction

		for k,v in pairs(abiPLV) do
			if k~=t2 then
				abiTempTable4[k]={}
				abiTempTable4[k][1]=abiPLV[k][1]
				abiTempTable4[k][2]=abiPLV[k][2]
			end		
		end

		-- but not if the current realm/faction. In this case, reset to zero
		if t2==t3 then
			abiTempTable4[t3]={}
			abiTempTable4[t3][1]=0
			abiTempTable4[t3][2]=0
		end

		abiPLV=table.wipe(abiPLV)
		abiPLV=abiTempTable4

		abiRealmHistory[t]="Deleted"
		abiFactionHistory[t]="-----"
		abiNameHistory[t]="-----"
		abiTimeHistory[t]="-----"
		abiRecordsHistory[t]="-----"
		_G["abiDeleteButton"..abiDeleteWhich]:Disable()
		abiBargainSearchButton:Disable()
		abiShowProfitLossFrames()
end



StaticPopupDialogs["abiDeleteRecords"]={
	text="You really want to delete these records?|n|nThis Cannot Be Undone !",
	button1="Yes",
	button2="No",

	OnAccept = function(self)
		abiDoTheDelete()
		AuctionFrame:SetAlpha(1)
		abiDisplayScanHistorys()
	end,

	OnCancel = function(self)
		AuctionFrame:SetAlpha(1)
		abiDisplayScanHistorys()
	end,

	OnHide = function(self)
		abiEnableAll()
		abiDelPopup=0
	end,
	showAlert = 1,
	timeout=0,
}



StaticPopupDialogs["abiDeleteTimeRecords"]={
	text="Delete these old records?|n|nThis Cannot Be Undone !|n|nThis will also empty your last search records.",
	button1="Yes",
	button2="No",

	OnAccept = function(self)
		 abiActuallyDeleteOldRecords()
		AuctionFrame:SetAlpha(1)
	end,

	OnCancel = function(self)
		AuctionFrame:SetAlpha(1)
	end,

	OnHide = function(self)
		abiEnableAll()
		abiDelPopup=0
	end,
	showAlert = 1,
	timeout=0,
}



function abiDeleteButton_OnLeave(passed)
	if abiDelPopup==0 then
		abiSetColors(passed,1,1,1,1)
		abiResetTextSize(passed)
	end
end



function abiDeleteButton_OnEnter(passed)
	if abiDelPopup==0 then
		abiSetColors(passed,1,0,0,1)
		_G["abiRealmFrame"..passed]:SetFontObject("GameFontNormalLarge")
		_G["abiFactionFrame"..passed]:SetFontObject("GameFontNormalLarge")
		_G["abiNameFrame"..passed]:SetFontObject("GameFontNormalLarge")
		_G["abiRecordsFrame"..passed]:SetFontObject("GameFontNormalLarge")
		_G["abiDaysFrame"..passed]:SetFontObject("GameFontNormalLarge")
	end
end



function abiDeleteMakeHeaders()
	CreateFrame("Button","abiDH1",abiDeletingFrame,"AbigailButtonTemplate")
	abiDH1:SetWidth(200)
	abiDH1:SetHeight(20)
	abiDH1:SetPoint("TOPLEFT",AuctionFrame,"TOP",-357,-54)
	abiDH1:SetText("Realm Name")
	abiDH1.tooltipText="|cffffff00The realm this data is for."

	CreateFrame("Button","abiDH2",abiDeletingFrame,"AbigailButtonTemplate")
	abiDH2:SetWidth(100)
	abiDH2:SetHeight(20)
	abiDH2:SetPoint("TOPLEFT",AuctionFrame,"TOP",-159,-54)
	abiDH2:SetText("Faction")
	abiDH2.tooltipText="|cffffff00Horde or Alliance."

	CreateFrame("Button","abiDH3",abiDeletingFrame,"AbigailButtonTemplate")
	abiDH3:SetWidth(130)
	abiDH3:SetHeight(20)
	abiDH3:SetScript("OnClick",abiRoundBuyout)
	abiDH3:SetPoint("TOPLEFT",AuctionFrame,"TOP",-61,-54)
	abiDH3:SetText("Last Char")
	abiDH3.tooltipText="|cffffff00The last character to do a|nAH scan on this realm/faction."

	CreateFrame("Button","abiDH4",abiDeletingFrame,"AbigailButtonTemplate")
	abiDH4:SetWidth(100)
	abiDH4:SetHeight(20)
	abiDH4:SetPoint("TOPLEFT",AuctionFrame,"TOP",67,-54)
	abiDH4:SetText("Records")
	abiDH4.tooltipText="|cffffff00How many records are stored|nfor this realm/faction."

	CreateFrame("Button","abiDH5",abiDeletingFrame,"AbigailButtonTemplate")
	abiDH5:SetWidth(100)
	abiDH5:SetHeight(20)
	abiDH5:SetPoint("TOPLEFT",AuctionFrame,"TOP",165,-54)
	abiDH5:SetText("Days")
	abiDH5.tooltipText="|cffffff00How many days since the|nlast AH scan was done."

	abiDeletingOldButton.tooltipText = "|cffffff00Delete all items that have not|nbeen seen for more than|nthis number of days."
	abiDeletingFindButton.tooltipText = "|cffffff00Find how many items that have not|nbeen seen for more than this|nnumber of days, without buy/sell info."
end



function abiDeleteMakeFrames()
	for abiloop=1,12 do
		abiCreateDelFrames("abiRealmFrame"..abiloop,50,0-(abiloop*20),180,"LEFT")
		abiCreateDelFrames("abiFactionFrame"..abiloop,250,0-(abiloop*20),80,"CENTER")
		abiCreateDelFrames("abiNameFrame"..abiloop,345,0-(abiloop*20),110,"CENTER")
		abiCreateDelFrames("abiRecordsFrame"..abiloop,475,0-(abiloop*20),80,"CENTER")
		abiCreateDelFrames("abiDaysFrame"..abiloop,570,0-(abiloop*20),85,"CENTER")
	end
end



function abiCreateDelFrames(f,x,y,w,j)
	f=abiDeletingFrame:CreateFontString(f)
	f:SetPoint("TOPLEFT",abiDeletingFrame,"TOPLEFT",x,y)
	f:SetFontObject(GameFontNormal)
	f:SetWidth(w)
	f:SetHeight(20)
	f:SetJustifyH(j)
	f:SetText(" ")
end



function abiGetScanHistorys()
	local temprealm
	local tempfaction
	if abiPlayerList==nil then
		abiPlayerList={}

		for k,v in pairs(abiPriceIndex) do
			tempfaction=""
			if string.sub(k,-8,-1)=="Alliance" then
				tempfaction="Alliance"
				temprealm=string.sub(k,1,#k-8)
			else
				tempfaction="Horde"
				temprealm=string.sub(k,1,#k-5)
			end
			abiPlayerList[k]=temprealm.."%"..tempfaction.."%".."Unknown".."%"..time()
		end
	end

	abiRealmHistory=table.wipe(abiRealmHistory)
	abiFactionHistory=table.wipe(abiFactionHistory)
	abiNameHistory=table.wipe(abiNameHistory)
	abiTimeHistory=table.wipe(abiTimeHistory)
	abiRecordsHistory=table.wipe(abiRecordsHistory)
	local count=1
	for k,v in pairs(abiPlayerList) do
		--k is the realm..faction name
		--v is the actual data
		abiRealmHistory[count],abiFactionHistory[count],abiNameHistory[count],abiTimeHistory[count]=strsplit("%",v)
		abiRecordsHistory[count]=abiGetNumRecords(abiRealmHistory[count],abiFactionHistory[count])
		count=count+1
	end
	abiDeleteScrollFrameUpdate()
end



function abiGetNumRecords(r,f)
	local count=0
	local t=r..f
	for k,v in pairs(abiPriceIndex[t]) do
		count=count+1
	end
	return count
end



function abiEmptyTheFrames()
	for abiloop=1,12 do
		_G["abiRealmFrame"..abiloop]:SetText("")
		_G["abiFactionFrame"..abiloop]:SetText("")
		_G["abiNameFrame"..abiloop]:SetText("")
		_G["abiRecordsFrame"..abiloop]:SetText("")
		_G["abiDaysFrame"..abiloop]:SetText("")
		_G["abiDeleteButton"..abiloop]:Disable()
	end
end



function abiDisplayScanHistorys()
	local abiOneToTwelve
	local abiDays
	abiEmptyTheFrames()
	abiStart=1+abiDeleteTableOffset
	abiFinish=12+abiDeleteTableOffset

	if abiFinish>#abiRealmHistory then
		abiFinish=#abiRealmHistory
		abiStart=abiFinish-11
	end

	if abiStart<1 then
		abiStart=1
	end

	if abiStart<=abiFinish then

		for abiloop=abiStart,abiFinish do

			abiOneToTwelve=abiloop-abiStart+1
			if abiRealmHistory[abiloop]=="Deleted" then
				_G["abiDeleteButton"..abiOneToTwelve]:Disable()
				abiDays="-----"
			else
				_G["abiDeleteButton"..abiOneToTwelve]:Enable()
				abiDays=abiGetNumDays(tonumber(abiTimeHistory[abiloop]))
			end

			abiSetColors(abiOneToTwelve,1,1,1,1)
			_G["abiRealmFrame"..abiOneToTwelve]:SetText(abiRealmHistory[abiloop])
			_G["abiFactionFrame"..abiOneToTwelve]:SetText(abiFactionHistory[abiloop])
			_G["abiNameFrame"..abiOneToTwelve]:SetText(abiNameHistory[abiloop])
			_G["abiRecordsFrame"..abiOneToTwelve]:SetText(abiRecordsHistory[abiloop])
			_G["abiDaysFrame"..abiOneToTwelve]:SetText(abiDays)

			abiResetTextSize(abiOneToTwelve)

		end
	end
end



function abiSetColors(w,r,g,b,a)
	_G["abiRealmFrame"..w]:SetTextColor(r,g,b,a)
	_G["abiFactionFrame"..w]:SetTextColor(r,g,b,a)
	_G["abiNameFrame"..w]:SetTextColor(r,g,b,a)
	_G["abiRecordsFrame"..w]:SetTextColor(r,g,b,a)
	_G["abiDaysFrame"..w]:SetTextColor(r,g,b,a)
end


function abiResetTextSize(passed)
	_G["abiRealmFrame"..passed]:SetFontObject(GameFontNormal)
	_G["abiFactionFrame"..passed]:SetFontObject(GameFontNormal)
	_G["abiNameFrame"..passed]:SetFontObject(GameFontNormal)
	_G["abiRecordsFrame"..passed]:SetFontObject(GameFontNormal)
	_G["abiDaysFrame"..passed]:SetFontObject(GameFontNormal)
end



function abiGetNumDays(passed)
	local ret=time()-passed
	ret=math.floor(ret/86400)
	return ret
end



function abiDeleteScrollFrameUpdate()

	if #abiRealmHistory~=0 then
		FauxScrollFrame_Update(abiDeleteScrollFrame,#abiRealmHistory,12,15)
		-- #abiRealmHistory is max entries, 12 is number of lines, 15 is pixel height of each line
		abiDeleteTableOffset=FauxScrollFrame_GetOffset(abiDeleteScrollFrame)
		abiDisplayScanHistorys()
		abiDeleteScrollFrame:Show()
	end

end



function abiDeletingOldButtonClicked()
	abiDisableAll()
	AuctionFrame:SetAlpha(0.5)
	abiDelPopup=1
	StaticPopup_Show("abiDeleteTimeRecords")
end


function abiActuallyDeleteOldRecords()
	-- remove those items from the price-index file
	-- Make sure it does not remove any items in the shopping list
	-- abiShoppingList = [Realm][ItemName] = costtype..%..max-spend-value

	local Link,Bhigh,Blow,Shigh,Slow,RecentSold,RecentBought,Ratio,Seen,TimeStamp,RecentHigh,RecentLow,PriceHistory
	local abiDelTable={}

	for k,v in pairs(abiPriceIndex) do
		for k2,v2 in pairs(abiPriceIndex[k]) do
			
			if abiShoppingList[k]==nil then
				abiShoppingList[k]={}
			end

			-- Now make sure its not in the shopping list, and put it in the abiDelTable if it is
			if abiShoppingList[k][k2]~=nil then
				if abiDelTable[k]==nil then
					abiDelTable[k]={}
				end
				abiDelTable[k][k2]=v2
			else
			
				if k2~="This Item Auctioned" and k2~="This Item No Longer Available" then
					Link,Bhigh,Blow,Shigh,Slow,RecentSold,RecentBought,Ratio,Seen,TimeStamp,RecentHigh,RecentLow,PriceHistory=abiDecodeIndex(v2)

					if abiGetNumDays(TimeStamp)<=abiDeletingSlider1FindValue() or
					Bhigh~=0 or Blow~=0 or Shigh~=0 or Slow~=0 then
						if abiDelTable[k]==nil then
							abiDelTable[k]={}
						end
						abiDelTable[k][k2]=v2
					end
				end

			end

		end
	end
	abiPriceIndex=abiDelTable
	abiDeletingFindButtonClicked()
	abiBargains=table.wipe(abiBargains)

	-- This line added to try and solve the Shopping Search thinking a Auction Delete is to be done
	abiLastSearch="Bargains"

	abiReadPricesButtonClicked("LeftButton",0)
	abiGetScanHistorys()
end



function abiDeletingFindButtonClicked()
-- find out how many records have this many days since last scanned.
-- report those that have a) no buy/sold records, b) have buy/sold records
	local Link,Bhigh,Blow,Shigh,Slow,RecentSold,RecentBought,Ratio,Seen,TimeStamp,RecentHigh,RecentLow,PriceHistory
	abiDelRecords=0
	abiOldRecords=0

	-- first do the abiPriceIndex table
	for k,v in pairs(abiPriceIndex) do
		for k2,v2 in pairs(abiPriceIndex[k]) do
			if k2~="This Item Auctioned" and k2~="This Item No Longer Available" then
				Link,Bhigh,Blow,Shigh,Slow,RecentSold,RecentBought,Ratio,Seen,TimeStamp,RecentHigh,RecentLow,PriceHistory=abiDecodeIndex(v2)

				if abiGetNumDays(TimeStamp)>abiDeletingSlider1FindValue() then
					abiOldRecords=abiOldRecords+1
					if Bhigh==0 and Blow==0 and Shigh==0 and Slow==0 then
						abiDelRecords=abiDelRecords+1
					end
				end
			end
		end
	end

	abiDeleteOverDays:SetText("Records over this number of days old : "..abiOldRecords)
	abiDeleteTotal:SetText("Old Records that can be deleted : "..abiDelRecords)

	if abiDelRecords>0 then
		abiDeletingOldButton:Enable()
	else
		abiDeletingOldButton:Disable()
	end
end



function abiDisableAll()
	abiPLButton:Disable()
	abiDeletingOldButton:Disable()
	abiDeletingFindButton:Disable()

	for abiloop=1,12 do
		_G["abiDeleteButton"..abiloop]:Disable()
	end

end



function abiEnableAll()
	abiPLButton:Enable()
	abiDeletingFindButton:Enable()

	if abiDelRecords>0 then
		abiDeletingOldButton:Enable()
	end

	abiStart=1+abiDeleteTableOffset
	abiFinish=12+abiDeleteTableOffset

	if abiFinish>#abiRealmHistory then
		abiFinish=#abiRealmHistory
		abiStart=abiFinish-11
	end

	if abiStart<1 then
		abiStart=1
	end

	if abiStart<=abiFinish then

		for abiloop=abiStart,abiFinish do

			abiOneToTwelve=abiloop-abiStart+1
			if abiRealmHistory[abiloop]~="Deleted" then
				_G["abiDeleteButton"..abiOneToTwelve]:Enable()
			end
		end
	end

end
